/**
 * Lecture ``Data Processing on Modern Hardware''
 *
 * Simple SIMD Exercise
 *
 * Based on code by Louis Woods (ETH Zurich, now Oracle Labs)
 */

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include <sys/time.h>

#define ARRAYSIZE 1000000000

int
main (int argc, char **argv)
{

    struct timeval start, end;
    long time1;

    /* allocate array of 8-bit integers */
    uint8_t *numberarray = malloc (ARRAYSIZE * sizeof (*numberarray));
    if (numberarray == NULL)
    {
        fprintf (stderr, "error during memory allocation\n");
        exit(EXIT_FAILURE);
    }

    /* populate array with random numbers */
    for (unsigned int i = 0; i < ARRAYSIZE; i++)
    {
        numberarray[i] = rand () % 100;
    }

    unsigned int scalarcnt = 0;

    gettimeofday (&start, NULL);

    /* TODO: improve this part with SSE Intrinsics */
    for (unsigned int i = 0; i < ARRAYSIZE; i++)
    {
        if(numberarray[i] > 42)
            scalarcnt++;
    }

    gettimeofday (&end, NULL);

    printf("scalar count = %d\n", scalarcnt);

    time1
        = (end.tv_sec - start.tv_sec) * 1000000 + (end.tv_usec - start.tv_usec);
    printf ("Required %lu usec to count\n", time1);

    return EXIT_SUCCESS;
}

